diff --git a/ldap/servers/slapd/libglobs.c b/ldap/servers/slapd/libglobs.c
index 77da741..7b34f85 100644
--- a/ldap/servers/slapd/libglobs.c
+++ b/ldap/servers/slapd/libglobs.c
@@ -3079,28 +3079,32 @@ config_set_pw_inhistory( const char *attrname, char *value, char *errorbuf, int
 int
 config_set_pw_lockduration( const char *attrname, char *value, char *errorbuf, int apply ) {
   int retVal = LDAP_SUCCESS;
-  long duration = 0; /* in minutes */
+  time_t duration = 0; /* in seconds */
 
   slapdFrontendConfig_t *slapdFrontendConfig = getFrontendConfig();
-  
+
   if ( config_value_is_null( attrname, value, errorbuf, 0 )) {
-	return LDAP_OPERATIONS_ERROR;
+    return LDAP_OPERATIONS_ERROR;
   }
 
   errno = 0;
   /* in seconds */
-  duration = parse_duration(value);
-
-  if ( errno == ERANGE || duration <= 0 || duration > (MAX_ALLOWED_TIME_IN_SECS - current_time()) ) {
-	slapi_create_errormsg(errorbuf, SLAPI_DSE_RETURNTEXT_SIZE, "password lockout duration \"%s\" is invalid. ", value);
-	retVal = LDAP_OPERATIONS_ERROR;
-	return retVal;
+  duration = parse_duration_time_t(value);
+
+  /*
+   * If the duration set is larger than time_t max - current time, we probably have
+   * made it to the heat death of the universe. Congratulations on finding this bug.
+   */
+  if ( errno == ERANGE || duration <= 0 || duration > (MAX_ALLOWED_TIME_IN_SECS_64 - slapi_current_utc_time()) ) {
+    slapi_create_errormsg(errorbuf, SLAPI_DSE_RETURNTEXT_SIZE, "password lockout duration \"%s\" is invalid. ", value);
+    retVal = LDAP_OPERATIONS_ERROR;
+    return retVal;
   }
 
   if ( apply ) {
     slapdFrontendConfig->pw_policy.pw_lockduration = duration;
   }
-  
+
   return retVal;
 }
 
@@ -3108,7 +3112,7 @@ config_set_pw_lockduration( const char *attrname, char *value, char *errorbuf, i
 int
 config_set_pw_resetfailurecount( const char *attrname, char *value, char *errorbuf, int apply ) {
   int retVal = LDAP_SUCCESS;
-  long duration = 0; /* in minutes */
+  time_t duration = 0; /* in seconds */
 
   slapdFrontendConfig_t *slapdFrontendConfig = getFrontendConfig();
   
@@ -3118,9 +3122,9 @@ config_set_pw_resetfailurecount( const char *attrname, char *value, char *errorb
 
   errno = 0;
   /* in seconds */  
-  duration = parse_duration(value);
+  duration = parse_duration_time_t(value);
 
-  if ( errno == ERANGE || duration < 0 || duration > (MAX_ALLOWED_TIME_IN_SECS - current_time()) ) {
+  if ( errno == ERANGE || duration <= 0 || duration > (MAX_ALLOWED_TIME_IN_SECS_64 - slapi_current_utc_time()) ) {
 	slapi_create_errormsg(errorbuf, SLAPI_DSE_RETURNTEXT_SIZE, "password reset count duration \"%s\" is invalid. ", value);
 	retVal = LDAP_OPERATIONS_ERROR;
 	return retVal;
@@ -4293,7 +4297,7 @@ config_set_auditfaillog( const char *attrname, char *value, char *errorbuf, int
 int
 config_set_pw_maxage( const char *attrname, char *value, char *errorbuf, int apply ) {
   int retVal = LDAP_SUCCESS;
-  long long age;
+  time_t age = 0;
 
   slapdFrontendConfig_t *slapdFrontendConfig = getFrontendConfig();
   
@@ -4303,15 +4307,9 @@ config_set_pw_maxage( const char *attrname, char *value, char *errorbuf, int app
   
   errno = 0;
   /* age in seconds */
-  age = slapi_parse_duration_longlong(value);
+  age = parse_duration_time_t(value);
 
-  if (age <= 0 || 
-#if defined(CPU_x86_64)
-      age > (MAX_ALLOWED_TIME_IN_SECS_64 - current_time())
-#else
-      age > (MAX_ALLOWED_TIME_IN_SECS - current_time())
-#endif
-  ) {
+  if (age <= 0 || age > (MAX_ALLOWED_TIME_IN_SECS_64 - slapi_current_utc_time()) ) {
 	slapi_create_errormsg(errorbuf, SLAPI_DSE_RETURNTEXT_SIZE, "%s: password maximum age \"%s\" is invalid.", attrname, value);
 	retVal = LDAP_OPERATIONS_ERROR;
 	return retVal;
@@ -4326,7 +4324,7 @@ config_set_pw_maxage( const char *attrname, char *value, char *errorbuf, int app
 int
 config_set_pw_minage( const char *attrname, char *value, char *errorbuf, int apply ) {
   int retVal = LDAP_SUCCESS;
-  long long age;
+  time_t age = 0;
   slapdFrontendConfig_t *slapdFrontendConfig = getFrontendConfig();
   
   if ( config_value_is_null( attrname, value, errorbuf, 1 )) {
@@ -4335,14 +4333,8 @@ config_set_pw_minage( const char *attrname, char *value, char *errorbuf, int app
   
   errno = 0;
   /* age in seconds */
-  age = slapi_parse_duration_longlong(value);
-  if (age < 0 ||
-#if defined(CPU_x86_64)
-      age > (MAX_ALLOWED_TIME_IN_SECS_64 - current_time())
-#else
-      age > (MAX_ALLOWED_TIME_IN_SECS - current_time())
-#endif
-  ) {
+  age = parse_duration_time_t(value);
+  if (age < 0 || age > (MAX_ALLOWED_TIME_IN_SECS_64 - slapi_current_utc_time()) ) {
 	slapi_create_errormsg(errorbuf, SLAPI_DSE_RETURNTEXT_SIZE, "%s: password minimum age \"%s\" is invalid.", attrname, value);
 	retVal = LDAP_OPERATIONS_ERROR;
 	return retVal;
@@ -4357,7 +4349,7 @@ config_set_pw_minage( const char *attrname, char *value, char *errorbuf, int app
 int
 config_set_pw_warning( const char *attrname, char *value, char *errorbuf, int apply ) {
   int retVal = LDAP_SUCCESS;
-  long long sec;
+  time_t sec;
 
   slapdFrontendConfig_t *slapdFrontendConfig = getFrontendConfig();
   
@@ -4367,7 +4359,7 @@ config_set_pw_warning( const char *attrname, char *value, char *errorbuf, int ap
   
   errno = 0;
   /* in seconds */
-  sec = slapi_parse_duration_longlong(value);
+  sec = parse_duration_time_t(value);
 
   if (errno == ERANGE || sec < 0) {
 	slapi_create_errormsg(errorbuf, SLAPI_DSE_RETURNTEXT_SIZE,
diff --git a/ldap/servers/slapd/log.c b/ldap/servers/slapd/log.c
index 3b4e672..922616f 100644
--- a/ldap/servers/slapd/log.c
+++ b/ldap/servers/slapd/log.c
@@ -2265,7 +2265,7 @@ vslapd_log_emergency_error(LOGFD fp, const char *msg, int locked)
     } else {
 #endif
         time_t    tnl;
-        tnl = current_time();
+        tnl = slapi_current_utc_time();
         if (format_localTime_log(tnl, sizeof(tbuf), tbuf, &size) != 0) {
             syslog(LOG_EMERG, "vslapd_log_emergency_error, Unable to format system time for message :: %s", msg);
             return;
@@ -2353,7 +2353,7 @@ vslapd_log_error(
     } else {
 #endif
         time_t    tnl;
-        tnl = current_time();
+        tnl = slapi_current_utc_time();
         if (format_localTime_log(tnl, sizeof(buffer), buffer, &blen) != 0) {
             PR_snprintf(buffer, sizeof(buffer), "vslapd_log_error, Unable to format system time for message :: %s", vbuf);
             log__error_emergency(buffer, 1 ,locked);
@@ -2543,7 +2543,7 @@ static int vslapd_log_access(char *fmt, va_list ap)
         }
     } else {
 #endif
-        tnl = current_time();
+        tnl = slapi_current_utc_time();
         if (format_localTime_log(tnl, sizeof(buffer), buffer, &blen) != 0) {
             /* MSG may be truncated */
             PR_snprintf(buffer, sizeof(buffer), "vslapd_log_access, Unable to format system time for message :: %s", vbuf);
@@ -2760,7 +2760,7 @@ log__open_accesslogfile(int logfile_state, int locked)
 
 
 	/* write the header in the log */
-	now = current_time();
+	now = slapi_current_utc_time();
 	log_convert_time (now, tbuf, 2 /* long */);
 	PR_snprintf (buffer,sizeof(buffer),"LOGINFO:Log file created at: %s (%lu)\n", tbuf, now);
 	LOG_WRITE(fpinfo, buffer, strlen(buffer), 0);
@@ -4627,7 +4627,7 @@ log__open_errorlogfile(int logfile_state, int locked)
 	}
 
 	/* write the header in the log */
-	now = current_time();
+	now = slapi_current_utc_time();
 	log_convert_time (now, tbuf, 2 /*long */);
 	PR_snprintf(buffer, sizeof(buffer),"LOGINFO:Log file created at: %s (%lu)\n", tbuf, now);
 	LOG_WRITE(fpinfo, buffer, strlen(buffer), 0);
@@ -4754,7 +4754,7 @@ log__open_auditlogfile(int logfile_state, int locked)
 	}
 
 	/* write the header in the log */
-	now = current_time();
+	now = slapi_current_utc_time();
 	log_convert_time (now, tbuf, 2 /*long */);	
 	PR_snprintf(buffer, sizeof(buffer), "LOGINFO:Log file created at: %s (%lu)\n", tbuf, now);
 	LOG_WRITE(fpinfo, buffer, strlen(buffer), 0);
@@ -4880,7 +4880,7 @@ log__open_auditfaillogfile(int logfile_state, int locked)
     }
 
     /* write the header in the log */
-    now = current_time();
+    now = slapi_current_utc_time();
     log_convert_time (now, tbuf, 2 /*long */);  
     PR_snprintf(buffer, sizeof(buffer), "LOGINFO:Log file created at: %s (%lu)\n", tbuf, now);
     LOG_WRITE(fpinfo, buffer, strlen(buffer), 0);
diff --git a/ldap/servers/slapd/main.c b/ldap/servers/slapd/main.c
index 252144f..be09217 100644
--- a/ldap/servers/slapd/main.c
+++ b/ldap/servers/slapd/main.c
@@ -1177,7 +1177,7 @@ main( int argc, char **argv)
 	}
 
 	{
-		time( &starttime );
+		starttime = slapi_current_utc_time();
 		slapd_daemon(&ports_info, tp);
 	}
 	slapi_log_err(SLAPI_LOG_INFO, "main", "slapd stopped.\n");
diff --git a/ldap/servers/slapd/monitor.c b/ldap/servers/slapd/monitor.c
index 8dd27af..92538b1 100644
--- a/ldap/servers/slapd/monitor.c
+++ b/ldap/servers/slapd/monitor.c
@@ -45,7 +45,7 @@ monitor_info(Slapi_PBlock *pb __attribute__((unused)),
 	char			buf[BUFSIZ];
 	struct berval		val;
 	struct berval	*vals[2];
-	time_t			curtime = current_time();
+	time_t			curtime = slapi_current_utc_time();
 	struct tm		utm;
 	Slapi_Backend		*be;
 	char			*cookie;
diff --git a/ldap/servers/slapd/operation.c b/ldap/servers/slapd/operation.c
index 3725b9f..0eb4c48 100644
--- a/ldap/servers/slapd/operation.c
+++ b/ldap/servers/slapd/operation.c
@@ -160,17 +160,13 @@ operation_init(Slapi_Operation *o, int flags)
 		slapi_sdn_init(&(o->o_sdn));
 		o->o_authtype = NULL;
 		o->o_isroot = 0;
-		o->o_time = current_time();
+		clock_gettime(CLOCK_MONOTONIC, &(o->o_hr_time_rel));
+		clock_gettime(CLOCK_REALTIME, &(o->o_hr_time_utc));
 		o->o_opid = 0;
 		o->o_connid = 0;
 		o->o_next = NULL;
 		o->o_flags= flags;
 		o->o_reverse_search_state = 0;
-		if ( config_get_accesslog_level() & LDAP_DEBUG_TIMING ) {
-			o->o_interval = PR_IntervalNow();
-		} else {
-			o->o_interval = (PRIntervalTime)0;
-		}
 		o->o_pagedresults_sizelimit = -1;
 	}
 
@@ -634,3 +630,23 @@ slapi_connection_remove_operation( Slapi_PBlock *pb __attribute__((unused)), Sla
 	PR_ExitMonitor(conn->c_mutex);
 	return (rc);
 }
+
+void
+slapi_operation_time_elapsed(Slapi_Operation *o, struct timespec *elapsed) {
+    struct timespec o_hr_time_now;
+    clock_gettime(CLOCK_MONOTONIC, &o_hr_time_now);
+
+    slapi_timespec_diff(&o_hr_time_now, &(o->o_hr_time_rel), elapsed);
+}
+
+void
+slapi_operation_time_initiated(Slapi_Operation *o, struct timespec *initiated) {
+    initiated->tv_sec = o->o_hr_time_utc.tv_sec;
+    initiated->tv_nsec = o->o_hr_time_utc.tv_nsec;
+}
+
+void
+slapi_operation_time_expiry(Slapi_Operation *o, time_t timeout, struct timespec *expiry) {
+    slapi_timespec_expire_rel(timeout, &(o->o_hr_time_rel), expiry);
+}
+
diff --git a/ldap/servers/slapd/opshared.c b/ldap/servers/slapd/opshared.c
index 133597f..6e1cca4 100644
--- a/ldap/servers/slapd/opshared.c
+++ b/ldap/servers/slapd/opshared.c
@@ -101,13 +101,11 @@ do_ps_service(Slapi_Entry *e, Slapi_Entry *eprev, ber_int_t chgtype, ber_int_t c
 void
 modify_update_last_modified_attr(Slapi_PBlock *pb, Slapi_Mods *smods)
 {
-    char        buf[20];
+    char        buf[SLAPI_TIMESTAMP_BUFSIZE];
     char        *plugin_dn = NULL;
     char        *binddn = NULL;
     struct berval    bv;
     struct berval    *bvals[2];
-    time_t        curtime;
-    struct tm    utm;
     Operation    *op;
     struct slapdplugin *plugin = NULL;
     struct slapi_componentid *cid = NULL;
@@ -171,9 +169,8 @@ modify_update_last_modified_attr(Slapi_PBlock *pb, Slapi_Mods *smods)
                            "modifiersname", bvals);
 
     /* fill in modifytimestamp */
-    curtime = current_time();
-    gmtime_r(&curtime, &utm);
-    strftime(buf, sizeof(buf), "%Y%m%d%H%M%SZ", &utm);
+    slapi_timestamp_utc_hr(buf, SLAPI_TIMESTAMP_BUFSIZE);
+
     bv.bv_val = buf;
     bv.bv_len = strlen(bv.bv_val);
     slapi_mods_add_modbvps(smods, LDAP_MOD_REPLACE | LDAP_MOD_BVALUES, 
@@ -548,12 +545,9 @@ op_shared_search (Slapi_PBlock *pb, int send_result)
 
       /* set the timelimit to clean up the too-long-lived-paged results requests */
       if (op_is_pagedresults(operation)) {
-        time_t optime, time_up;
-        int tlimit;
+        int32_t tlimit;
         slapi_pblock_get( pb, SLAPI_SEARCH_TIMELIMIT, &tlimit );
-        slapi_pblock_get( pb, SLAPI_OPINITIATED_TIME, &optime );
-        time_up = (tlimit==-1 ? -1 : optime + tlimit); /* -1: no time limit */
-        pagedresults_set_timelimit(pb_conn, operation, time_up, pr_idx);
+        pagedresults_set_timelimit(pb_conn, operation, (time_t)tlimit, pr_idx);
       }
     
       /*
diff --git a/ldap/servers/slapd/pagedresults.c b/ldap/servers/slapd/pagedresults.c
index 673019a..7ae1b85 100644
--- a/ldap/servers/slapd/pagedresults.c
+++ b/ldap/servers/slapd/pagedresults.c
@@ -58,7 +58,6 @@ pagedresults_parse_control_value( Slapi_PBlock *pb,
     Operation *op = NULL;
     BerElement *ber = NULL;
     PagedResults *prp = NULL;
-    time_t ctime = current_time();
     int i;
     int maxreqs = config_get_maxsimplepaged_per_conn();
 
@@ -131,7 +130,7 @@ pagedresults_parse_control_value( Slapi_PBlock *pb,
                     prp->pr_current_be = be;
                     *index = i;
                     break;
-                } else if (((prp->pr_timelimit > 0) && (ctime > prp->pr_timelimit)) || /* timelimit exceeded */
+                } else if ( slapi_timespec_expire_check(&(prp->pr_timelimit_hr)) == TIMER_EXPIRED || /* timelimit exceeded */
                            (prp->pr_flags & CONN_FLAG_PAGEDRESULTS_ABANDONED) /* abandoned */) {
                     _pr_cleanup_one_slot(prp);
                     conn->c_pagedresults.prl_count--;
@@ -198,7 +197,7 @@ bail:
     prp = conn->c_pagedresults.prl_list;
     for (i = 0; i < conn->c_pagedresults.prl_maxlen; i++, prp++) {
         if (prp->pr_current_be &&
-            (((prp->pr_timelimit > 0) && (ctime > prp->pr_timelimit)) || /* timelimit exceeded */
+            (slapi_timespec_expire_check(&(prp->pr_timelimit_hr)) == TIMER_EXPIRED || /* timelimit exceeded */
              (prp->pr_flags & CONN_FLAG_PAGEDRESULTS_ABANDONED)) /* abandoned */) {
             _pr_cleanup_one_slot(prp);
             conn->c_pagedresults.prl_count--;
@@ -698,7 +697,7 @@ pagedresults_set_timelimit(Connection *conn, Operation *op,
     if (conn && (index > -1)) {
         PR_EnterMonitor(conn->c_mutex);
         if (index < conn->c_pagedresults.prl_maxlen) {
-            conn->c_pagedresults.prl_list[index].pr_timelimit = timelimit;
+            slapi_timespec_expire_at(timelimit, &(conn->c_pagedresults.prl_list[index].pr_timelimit_hr));
         }
         PR_ExitMonitor(conn->c_mutex);
         rc = 0;
@@ -899,7 +898,6 @@ int
 pagedresults_is_timedout_nolock(Connection *conn)
 {
     PagedResults *prp = NULL;
-    time_t ctime;
 
     slapi_log_err(SLAPI_LOG_TRACE, "pagedresults_is_timedout", "=>\n");
 
@@ -908,14 +906,11 @@ pagedresults_is_timedout_nolock(Connection *conn)
         return 0;
     }
 
-    ctime = current_time();
     prp = conn->c_pagedresults.prl_list;
     if (prp && (1 == conn->c_pagedresults.prl_maxlen)) {
-        if (prp->pr_current_be && (prp->pr_timelimit > 0)) {
-            if (ctime > prp->pr_timelimit) {
-                slapi_log_err(SLAPI_LOG_TRACE, "pagedresults_is_timedout", "<= true\n");
-                return 1;
-            }
+        if (slapi_timespec_expire_check(&(prp->pr_timelimit_hr)) == TIMER_EXPIRED) {
+            slapi_log_err(SLAPI_LOG_TRACE, "pagedresults_is_timedout", "<= true\n");
+            return 1;
         }
     }
     slapi_log_err(SLAPI_LOG_TRACE, "<-- pagedresults_is_timedout", "<= false 2\n");
@@ -939,7 +934,8 @@ pagedresults_reset_timedout_nolock(Connection *conn)
 
     for (i = 0; i < conn->c_pagedresults.prl_maxlen; i++) {
         prp = conn->c_pagedresults.prl_list + i;
-        prp->pr_timelimit = 0;
+        prp->pr_timelimit_hr.tv_sec = 0;
+        prp->pr_timelimit_hr.tv_nsec = 0;
     }
     slapi_log_err(SLAPI_LOG_TRACE, "pagedresults_reset_timedout", "<=\n");
     return 0;
diff --git a/ldap/servers/slapd/pblock.c b/ldap/servers/slapd/pblock.c
index 69fdd70..429329a 100644
--- a/ldap/servers/slapd/pblock.c
+++ b/ldap/servers/slapd/pblock.c
@@ -581,7 +581,7 @@ int slapi_pblock_get(Slapi_PBlock *pblock, int arg, void *value) {
                           "slapi_pblock_get", "Operation is NULL and hence cannot access SLAPI_OPINITIATED_TIME \n");
             return (-1);
         }
-        (*(time_t *)value) = pblock->pb_op->o_time;
+        (*(time_t *)value) = pblock->pb_op->o_hr_time_utc.tv_sec;
         break;
     case SLAPI_REQUESTOR_ISROOT:
         if (pblock->pb_intop != NULL) {
@@ -2321,9 +2321,6 @@ int slapi_pblock_set(Slapi_PBlock *pblock, int arg, void *value) {
         pblock->pb_op = (Operation *)value;
         break;
     case SLAPI_OPINITIATED_TIME:
-        if (pblock->pb_op != NULL) {
-            pblock->pb_op->o_time = *((time_t *)value);
-        }
         break;
     case SLAPI_REQUESTOR_ISROOT:
         _pblock_assert_pb_intop(pblock);
diff --git a/ldap/servers/slapd/pw.c b/ldap/servers/slapd/pw.c
index 0ebc448..e75e447 100644
--- a/ldap/servers/slapd/pw.c
+++ b/ldap/servers/slapd/pw.c
@@ -618,7 +618,7 @@ update_pw_info ( Slapi_PBlock *pb , char *old_pw)
 	internal_op = slapi_operation_is_flag_set(operation, SLAPI_OP_FLAG_INTERNAL);
 	target_dn = slapi_sdn_get_ndn(sdn);
 	pwpolicy = new_passwdPolicy(pb, target_dn);
-	cur_time = current_time();
+	cur_time = slapi_current_utc_time();
 	slapi_mods_init(&smods, 0);
 	
 	if (slapi_entry_attr_hasvalue(e, SLAPI_ATTR_OBJECTCLASS, "shadowAccount")) {
@@ -762,7 +762,7 @@ check_pw_minage ( Slapi_PBlock *pb, const Slapi_DN *sdn, struct berval **vals __
 			slapi_ch_free((void **) &passwordAllowChangeTime );
 
 			/* check if allow to change the password */
-			cur_time_str = format_genTime ( current_time() );
+			cur_time_str = format_genTime ( slapi_current_utc_time() );
 			if ( difftime ( pw_allowchange_date,
 							parse_genTime ( cur_time_str )) > 0 )
 			{
@@ -1205,7 +1205,7 @@ update_pw_history( Slapi_PBlock *pb, const Slapi_DN *sdn, char *old_pw )
 		vacnt_todelete = vacnt - pwpolicy->pw_inhistory;
 	}
 
-	cur_time = current_time();
+	cur_time = slapi_current_utc_time();
 	str = format_genTime(cur_time);
 	/* values_replace is sorted. */
 	if (old_pw) {
@@ -1406,7 +1406,7 @@ add_password_attrs( Slapi_PBlock *pb, Operation *op __attribute__((unused)), Sla
 			/* must change password when first time logon */
 			bv.bv_val = format_genTime ( NO_TIME );
 		} else if ( pwpolicy->pw_exp ) {
-			exptime = time_plus_sec(current_time(), pwpolicy->pw_maxage);
+			exptime = time_plus_sec(slapi_current_utc_time(), pwpolicy->pw_maxage);
 			bv.bv_val = format_genTime(exptime);
 		}
 		bv.bv_len = strlen( bv.bv_val );
@@ -1418,7 +1418,7 @@ add_password_attrs( Slapi_PBlock *pb, Operation *op __attribute__((unused)), Sla
 			/* must change password when first time logon */
 			bv.bv_val = slapi_ch_smprintf("0");
 		} else {
-			exptime = current_time() / _SEC_PER_DAY;
+			exptime = slapi_current_utc_time() / _SEC_PER_DAY;
 			bv.bv_val = slapi_ch_smprintf("%ld", exptime);
 		}
 		bv.bv_len = strlen(bv.bv_val);
@@ -1435,8 +1435,8 @@ add_password_attrs( Slapi_PBlock *pb, Operation *op __attribute__((unused)), Sla
 	 * the password if we set a passwordallowchangetime in the future.
 	 */
 	if ( !has_allowchangetime && pwpolicy->pw_minage != 0 && 
-		(has_expirationtime && existing_exptime > current_time()) ) {
-		bv.bv_val = format_genTime ( time_plus_sec ( current_time (), pwpolicy->pw_minage ) );
+		(has_expirationtime && existing_exptime > slapi_current_utc_time()) ) {
+		bv.bv_val = format_genTime ( time_plus_sec ( slapi_current_utc_time(), pwpolicy->pw_minage ) );
 		bv.bv_len = strlen( bv.bv_val );
 
 		slapi_entry_attr_merge( e, "passwordallowchangetime", bvals );
@@ -1792,7 +1792,7 @@ new_passwdPolicy(Slapi_PBlock *pb, const char *dn)
 				slapi_attr_get_type(attr, &attr_name);
 				if (!strcasecmp(attr_name, "passwordminage")) {
 					if ((sval = attr_get_present_values(attr))) {
-						pwdpolicy->pw_minage = slapi_value_get_timelonglong(*sval);
+						pwdpolicy->pw_minage = slapi_value_get_time_time_t(*sval);
 						if (-1 == pwdpolicy->pw_minage) {
 							slapi_log_err(SLAPI_LOG_ERR,
 								"new_passwdPolicy", "%s - Invalid passwordMinAge: %s\n",
@@ -1804,7 +1804,7 @@ new_passwdPolicy(Slapi_PBlock *pb, const char *dn)
 				else
 				if (!strcasecmp(attr_name, "passwordmaxage")) {
 					if ((sval = attr_get_present_values(attr))) {
-						pwdpolicy->pw_maxage = slapi_value_get_timelonglong(*sval);
+						pwdpolicy->pw_maxage = slapi_value_get_time_time_t(*sval);
 						if (-1 == pwdpolicy->pw_maxage) {
 							slapi_log_err(SLAPI_LOG_ERR,
 								"new_passwdPolicy", "%s - Invalid passwordMaxAge: %s\n",
@@ -1816,7 +1816,7 @@ new_passwdPolicy(Slapi_PBlock *pb, const char *dn)
 				else
 				if (!strcasecmp(attr_name, "passwordwarning")) {
 					if ((sval = attr_get_present_values(attr))) {
-						pwdpolicy->pw_warning = slapi_value_get_timelonglong(*sval);
+						pwdpolicy->pw_warning = slapi_value_get_time_time_t(*sval);
 						if (-1 == pwdpolicy->pw_warning) {
 							slapi_log_err(SLAPI_LOG_ERR,
 								"new_passwdPolicy", "%s - Invalid passwordWarning: %s\n",
@@ -1861,7 +1861,7 @@ new_passwdPolicy(Slapi_PBlock *pb, const char *dn)
 				else
 				if (!strcasecmp(attr_name, "passwordlockoutduration")) {
 					if ((sval = attr_get_present_values(attr))) {
-						pwdpolicy->pw_lockduration = slapi_value_get_timelong(*sval);
+						pwdpolicy->pw_lockduration = slapi_value_get_time_time_t(*sval);
 					}
 				}
 				else
@@ -2172,19 +2172,15 @@ check_pw_duration_value(const char *attr_name, char *value,
                         long minval, long maxval, char *errorbuf, size_t ebuflen)
 {
 	int retVal = LDAP_SUCCESS;
-	long long age;
+	time_t age;
 
-	age = slapi_parse_duration_longlong(value);
+	age = slapi_parse_duration(value);
 	if (-1 == age) {
 		slapi_create_errormsg(errorbuf, ebuflen, "password minimum age \"%s\" is invalid. ", value);
 		retVal = LDAP_CONSTRAINT_VIOLATION;
 	} else if (0 == strcasecmp(CONFIG_PW_LOCKDURATION_ATTRIBUTE, attr_name)) {
 		if ( (age <= 0) ||
-#if defined(CPU_x86_64)
-			 (age > (MAX_ALLOWED_TIME_IN_SECS_64 - current_time())) ||
-#else
-			 (age > (MAX_ALLOWED_TIME_IN_SECS - current_time())) ||
-#endif
+             (age > (MAX_ALLOWED_TIME_IN_SECS_64 - slapi_current_utc_time())) ||
 			 ((-1 != minval) && (age < minval)) ||
 			 ((-1 != maxval) && (age > maxval))) {
 			slapi_create_errormsg(errorbuf, ebuflen, "%s: \"%s\" seconds is invalid. ", attr_name, value);
@@ -2192,11 +2188,7 @@ check_pw_duration_value(const char *attr_name, char *value,
 		}
 	} else {
 		if ( (age < 0) ||
-#if defined(CPU_x86_64)
-			 (age > (MAX_ALLOWED_TIME_IN_SECS_64 - current_time())) ||
-#else
-			 (age > (MAX_ALLOWED_TIME_IN_SECS - current_time())) ||
-#endif
+			 (age > (MAX_ALLOWED_TIME_IN_SECS_64 - slapi_current_utc_time())) ||
 			 ((-1 != minval) && (age < minval)) ||
 			 ((-1 != maxval) && (age > maxval))) {
 			slapi_create_errormsg(errorbuf, ebuflen, "%s: \"%s\" seconds is invalid. ", attr_name, value);
@@ -2212,11 +2204,11 @@ check_pw_resetfailurecount_value(const char *attr_name __attribute__((unused)),
                                  long minval __attribute__((unused)), long maxval __attribute__((unused)), char *errorbuf, size_t ebuflen)
 {
 	int retVal = LDAP_SUCCESS;
-	long duration = 0; /* in minutes */
+	time_t duration = 0; /* in seconds */
 
 	/* in seconds */  
-	duration = strtol (value, NULL, 0);
-	if ( duration < 0 || duration > (MAX_ALLOWED_TIME_IN_SECS - current_time()) ) {
+    duration = parse_duration_time_t(value);
+	if ( duration < 0 || duration > (MAX_ALLOWED_TIME_IN_SECS_64 - slapi_current_utc_time()) ) {
 		slapi_create_errormsg(errorbuf, ebuflen, "password reset count duration \"%s\" seconds is invalid.", value);
 		retVal = LDAP_CONSTRAINT_VIOLATION;
 	}
@@ -2375,7 +2367,7 @@ slapi_check_account_lock ( Slapi_PBlock *pb, Slapi_Entry * bind_target_entry, in
 						0, NULL );
 			goto locked;
 		}
-		cur_time = current_time();
+		cur_time = slapi_current_utc_time();
 		cur_time_str = format_genTime( cur_time);
 		if ( difftime ( parse_genTime( cur_time_str ), unlock_time )  < 0 ) {
 
@@ -2437,7 +2429,7 @@ slapi_pwpolicy_is_expired(Slapi_PWPolicy *pwpolicy, Slapi_Entry *e, time_t *expi
             if (expiration_val) {
                 _expire_time = parse_genTime(expiration_val);
 
-                cur_time = current_time();
+                cur_time = slapi_current_utc_time();
                 cur_time_str = format_genTime(cur_time);
 
                 if ((_expire_time != NO_TIME) && (_expire_time != NOT_FIRST_TIME) &&
@@ -2509,7 +2501,7 @@ slapi_pwpolicy_is_locked(Slapi_PWPolicy *pwpolicy, Slapi_Entry *e, time_t *unloc
                     *unlock_time = (time_t)0;
                 }
             } else {
-                cur_time = current_time();
+                cur_time = slapi_current_utc_time();
                 cur_time_str = format_genTime(cur_time);
 
                 if (difftime(parse_genTime(cur_time_str), _unlock_time)  < 0) {
diff --git a/ldap/servers/slapd/pw_mgmt.c b/ldap/servers/slapd/pw_mgmt.c
index a01afc5..677f11f 100644
--- a/ldap/servers/slapd/pw_mgmt.c
+++ b/ldap/servers/slapd/pw_mgmt.c
@@ -56,7 +56,7 @@ need_new_pw( Slapi_PBlock *pb, long *t, Slapi_Entry *e, int pwresponse_req )
 		}
 	}
 
-	cur_time = current_time();
+	cur_time = slapi_current_utc_time();
 
 	/* get passwordExpirationTime attribute */
 	passwordExpirationTime= slapi_entry_attr_get_charptr(e, "passwordExpirationTime");
diff --git a/ldap/servers/slapd/pw_retry.c b/ldap/servers/slapd/pw_retry.c
index cb283ba..80b8944 100644
--- a/ldap/servers/slapd/pw_retry.c
+++ b/ldap/servers/slapd/pw_retry.c
@@ -51,7 +51,7 @@ int update_pw_retry ( Slapi_PBlock *pb )
 		return ( 1 );
 	}
 
-    cur_time = current_time();
+    cur_time = slapi_current_utc_time();
 
     /* check if the retry count can be reset. */
 	retryCountResetTime= slapi_entry_attr_get_charptr(e, "retryCountResetTime");
@@ -150,8 +150,7 @@ int set_retry_cnt_mods(Slapi_PBlock *pb, Slapi_Mods *smods, int count)
 				/* lock until admin reset password */
 				unlock_time = NO_TIME;
 			} else {
-				unlock_time = time_plus_sec ( current_time(),
-											  pwpolicy->pw_lockduration );
+				unlock_time = time_plus_sec ( slapi_current_utc_time(), pwpolicy->pw_lockduration);
 			}
 			timestr= format_genTime ( unlock_time );
 			slapi_mods_add_string(smods, LDAP_MOD_REPLACE, "accountUnlockTime", timestr);
diff --git a/ldap/servers/slapd/regex.c b/ldap/servers/slapd/regex.c
index 19a9b1d..a19ef2c 100644
--- a/ldap/servers/slapd/regex.c
+++ b/ldap/servers/slapd/regex.c
@@ -71,7 +71,7 @@ int
 slapi_re_exec( Slapi_Regex *re_handle, const char *subject, time_t time_up )
 {
     int rc;
-    time_t curtime = current_time();
+    time_t curtime = slapi_current_utc_time();
 
     if (NULL == re_handle || NULL == re_handle->re_pcre || NULL == subject) {
         return LDAP_PARAM_ERROR;
@@ -105,6 +105,52 @@ slapi_re_exec( Slapi_Regex *re_handle, const char *subject, time_t time_up )
 }
 
 /**
+ * Matches a compiled regular expression pattern against a given string.
+ * A thin wrapper of pcre_exec.
+ *
+ * unlike slapi_re_exec, this has no timeout. The timeout was only checked
+ * at the start of the function, not during or after, so was essentially
+ * meaningless.
+ *
+ * \param re_handle The regex handler returned from slapi_re_comp.
+ * \param subject A string to be checked against the compiled pattern.
+ * \return This function returns 0 if the string did not match.
+ * \return This function returns 1 if the string matched.
+ * \return This function returns other values if any error occurred.
+ * \warning The regex handler should be released by slapi_re_free().
+ */
+int32_t
+slapi_re_exec_nt( Slapi_Regex *re_handle, const char *subject) {
+    int32_t rc;
+
+    if (NULL == re_handle || NULL == re_handle->re_pcre || NULL == subject) {
+        return LDAP_PARAM_ERROR;
+    }
+
+    if (NULL == re_handle->re_ovector) {
+        re_handle->re_oveccount = OVECCOUNT;
+        re_handle->re_ovector = (int *)slapi_ch_malloc(sizeof(int) * OVECCOUNT);
+    }
+
+    rc = pcre_exec( re_handle->re_pcre, /* the compiled pattern */
+                    NULL,            /* no extra data */
+                    subject,         /* the subject string */
+                    strlen(subject), /* the length of the subject */
+                    0,               /* start at offset 0 in the subject */
+                    0,               /* default options */
+                    re_handle->re_ovector, /* output vector for substring info */
+                    re_handle->re_oveccount ); /* number of elems in the ovector */
+
+    if (rc >= 0) {
+        return 1;    /* matched */
+    } else {
+        return 0;    /* did not match */
+    }
+
+    return rc;
+}
+
+/**
  * Substitutes '&' or '\#' in the param src with the matched string.
  *
  * \param re_handle The regex handler returned from slapi_re_comp.
diff --git a/ldap/servers/slapd/result.c b/ldap/servers/slapd/result.c
index a16c8e1..cf39902 100644
--- a/ldap/servers/slapd/result.c
+++ b/ldap/servers/slapd/result.c
@@ -1944,8 +1944,6 @@ notes2str( unsigned int notes, char *buf, size_t buflen )
 }
 
 
-#define ETIME_BUFSIZ 16         /* room for 99999999.999999 */
-
 static void
 log_result( Slapi_PBlock *pb, Operation *op, int err, ber_tag_t tag, int nentries )
 {
@@ -1963,13 +1961,10 @@ log_result( Slapi_PBlock *pb, Operation *op, int err, ber_tag_t tag, int nentrie
 
 	internal_op = operation_is_flag_set( op, OP_FLAG_INTERNAL );
 
-	if ( (config_get_accesslog_level() & LDAP_DEBUG_TIMING) &&
-			(op->o_interval != (PRIntervalTime) 0) ) {
-		PRIntervalTime delta = PR_IntervalNow() - op->o_interval;
-		PR_snprintf(etime, ETIME_BUFSIZ, "%f", (PRFloat64)delta/PR_TicksPerSecond());
-	} else {
-		PR_snprintf(etime, ETIME_BUFSIZ, "%ld", current_time() - op->o_time);
-	}
+	struct timespec o_hr_time_end;
+	slapi_operation_time_elapsed(op, &o_hr_time_end);
+
+	snprintf(etime, ETIME_BUFSIZ, "%" PRId64 ".%010" PRId64 "", o_hr_time_end.tv_sec, o_hr_time_end.tv_nsec);
 
 	slapi_pblock_get(pb, SLAPI_OPERATION_NOTES, &operation_notes);
 
diff --git a/ldap/servers/slapd/sasl_map.c b/ldap/servers/slapd/sasl_map.c
index bc4381e..a7ba1de 100644
--- a/ldap/servers/slapd/sasl_map.c
+++ b/ldap/servers/slapd/sasl_map.c
@@ -585,7 +585,7 @@ sasl_map_check(sasl_map_data *dp, char *sasl_user_and_realm, char **ldap_search_
 			dp->regular_expression, recomp_result?recomp_result:"unknown");
 	} else {
 		/* Matches the compiled regex against sasl_user_and_realm */
-		matched = slapi_re_exec(re, sasl_user_and_realm, -1 /* no timelimit */);
+		matched = slapi_re_exec_nt(re, sasl_user_and_realm);
 		slapi_log_err(SLAPI_LOG_TRACE, "sasl_map_check", "regex: %s, id: %s, %s\n",
 			dp->regular_expression, sasl_user_and_realm,
 			matched ? "matched" : "didn't match" );
@@ -643,7 +643,7 @@ sasl_map_check(sasl_map_data *dp, char *sasl_user_and_realm, char **ldap_search_
 			}
 		} else {
 			slapi_log_err(SLAPI_LOG_ERR,
-				"sasl_map_check", "slapi_re_exec failed: "
+				"sasl_map_check", "slapi_re_exec_nt failed: "
 				"regex: %s, subject: %s (%d)\n",
 				dp->regular_expression, sasl_user_and_realm, matched);
 		}
